SET T muuttujaindeksi (dimensio on 2*ORD(T)) / t1*t100 /;
SCALAR N; N = 2*CARD(T);

FREE VARIABLE FX kohdefunktio;
VARIABLES X1(T) parittomat muuttujat
          X2(T) parilliset muuttujat;
EQUATION FUNC minimoitavan funktion lauseke
         CTR1 rajoite 1
         CTR2 rajoite 2
         CTR3 rajoite 3;

FUNC.. FX =E= SUM(T, 100*SQR(X2(T) - SQR(X1(T)))) + SUM(T, SQR(1 - X1(T)));
CTR1.. SUM(T, SQR(X1(T))) + SUM(T, SQR(X2(T))) =L= 0.95*N;
CTR2.. X2('t10') + X1('t90') =L= 1.5;
CTR3.. X1('t32') + x2('t50') =L= 1.5;

* Alkuarvaus
* X1.L(T) = 1.0; X2.L(T) = 1.0;
X1.L(T) = 0.5; X2.L(T) = 1.5;
X1.LO(T) = -2.0; X1.UP(T) = 2.0;
X2.LO(T) = -2.0; X2.UP(T) = 2.0;

MODEL ROSENBR / ALL /;
OPTION NLP = MINOS5; ROSENBR.OPTFILE = 1;
SOLVE ROSENBR MINIMIZING FX USING NLP;
